class BesucherGruppe extends Thread
{
   public BesucherGruppe (Restaurant r, int anz, int zeit) 
   {  // erzeugt eine Gruppe, die mit n Personen fr eine bestimmte
      // Zeitdauer im Restaurrant r essen mchte
      restaurant = r;
      anzPersonen = anz;
      verweilDauer = zeit;
      nummer = gruppenZhler++;   // nur fr die Ausgabe
   }

   public void run () 
   {  System.out.println(this + " betritt das Restaurant.");
      Tisch unserTisch = restaurant.platzieren(anzPersonen);
      System.out.println(this + " bleibt " + verweilDauer +
                         " Zeiteinheiten lang.");
      try { sleep(verweilDauer); }
          catch (InterruptedException e) {};
      System.out.println(this + " steht auf.");
      restaurant.verlassen(unserTisch,anzPersonen);
      System.out.println(this + " verlt das Restaurant.");
   }

   public int anzahlPersonen() 
   {  return anzPersonen;  }

   private int anzPersonen;       // wie viele Leute gehren zur Gruppe
   private int verweilDauer;      // wie lange will die Gruppe bleiben
   private Restaurant restaurant; // dort mchte die Gruppe essen
   
   private int nummer; // nur fr die Ausgabe
   private static int gruppenZhler = 1;
   
   public String toString ()
   { return "Gruppe " + nummer + " mit " +
            anzPersonen + " Person(en)"; }
}
